/* test the mouse subroutines program      Version 1.0
 *
 *  Started 24 Sept 1991
 *  By Thomas Kellar
 *  Copyright (c) 1991 Thomas Kellar
 *
 * Written for Mix Software Power C compiler
 *
 * external references to
 *
 *  mcenter,mconstrain,mcursor_off,mgetbp,mgetint,mgetpress,
 *  mgetrelease,mgetstatus,mgettype,mgetver,minitial,mrestore,
 *  msave,msetpos,mreset
 *
 ************************************************************************/

#include <stdio.h>
#include <graphics.h>
#include <bios.h>
#include <dos.h>
#include <malloc.h>


#define true   1
#define false  0

#define MSIZE  1000     /* could be considered small - 250 - interrupts */


/* global variables */
int  constr = false;    /* true iff constrain() called */
int  xdivisor;          /* straighten out the output for the modes */
int  ydivisor;
int  bsave = true;      /* test the save/restore stuff */
int  graphic = true;    /* iff one of the graphics modes */
int  mint = false;      /* true iff miinitial called */

unsigned int  far *moubuf;     /* could allocate at run time but... */


main(argc,argv)
 int    argc;
 char   **argv;
   {
   int cmode = 18;       /* video mode default */
   int kst;              /* keystroke inputter */
   int x,y;              /* the pointerish x and y co-ordinates */
   int a,b;              /* used in mgetint() call */
   int lpress=false;     /* true of the left button (0) has been pushed */
   int rpress=false;
   int plotpix=true;     /* if true the setpixel */
   int color;            /* current color of the pixel putter */
   int index;            /* used for a slowing wait */

/* if passed an integer argument on the command line */
   if (argc > 1) cmode = atoi(argv[1]);


   printf("Test mouse interface version 1.0. ");
   printf("Copyright 1991 Thomas Kellar.\n");
   printf("Please Type any key to continue....");

   getch();

   if (setvmode(cmode) == cmode)
      {

      switch(cmode)
        {
        case  4 :
        case  5 :
        case  9 :
        case 13 :
        case 19 : xdivisor = 2;
                  break;
        default : xdivisor = 1;
                  break;
        }
      switch(cmode)
        {
        case 13 : ydivisor = 2;
                  break;
        default : ydivisor = 1;
                  break;
        }

      if (cmode <= 3) graphic = false;
      if (cmode == 7) graphic = false;
      if (cmode >= 0x50 && cmode <= 0x5A) graphic = false;

      if (!mreset())        /* reset mouse */
         {
         fprintf(stderr,"Cannot initialize the Mouse!\n");
         sleep(1);
         setvmode(DEFAULTMODE);
         exit(0);
         }

      display_screen();


/* loop forever (relatively speaking) and while looping see if
    - keyboard has been hit (not too violently)
    - left mouse button has been pressed
    - left mouse button has been released
    - right mouse button has been pressed
    - right mouse button has been released
    and after that process the effects of the above see ifs
*/
      while (true)            /* some people do not like these */
        {

        if (kbhit() != 0)     /* poll the keyboard */
           {
           kst = getch();
           if (kst != 27)     /* the Esc is the escape from mousecatraz */
              pr_key(kst);    /* process the keystroke */
           else
              break;      /* Esc key */
           }

        faster:

        if (!mint)     /* these below are polled versions */
           {
           if (mgetpress(0,&x,&y) != 0)   /* poll the left 0 button */
              lpress = true;

/* test the other routine..faster */
           if (mgetbp(1) > 0)  /* poll the right 1 button */
              rpress = true;

           if (mgetrelease(0,&x,&y) != 0)  /* poll left 0 for release */
              lpress = false;

           if (mgetrelease(1,&x,&y) != 0)  /* poll right 1 for release */
              rpress = false;
           }             /* interrupt version */

        /* this is the interrupt version */
        if (mint)
           {
           if (mgetint(&a,&b,&x,&y))
              {
              if ( (a & 0x02) == 0x02) lpress = true;
              if ( (a & 0x04) == 0x04) lpress = false;
              if ( (a & 0x08) == 0x08) rpress = true;
              if ( (a & 0x10) == 0x10) rpress = false;
              if ( (a & 0x01) == 0x01)
                 {
                 poscurs(24,0);
                 printf("%3d %3d ",x,y);
                 }
              }
           }

        if (rpress || lpress)
           {

           /* slow down the code to test interrupts and statusing of the
              mouse and see what happins...if right button slow down */
           if (rpress) for (index = 0; index <31000; index ++) ;

           if (!mint) mgetstatus(&x,&y);

           if (rpress) color = 9;                   /* blue */
           if (lpress) color = 14;                  /* yellow */
           if (lpress && rpress) color = 12;        /* red */

           x = x/xdivisor;      /* mouse sends back wrong values */
           y = y/ydivisor;      /* true mode 13 too for y */

                           /* see if in exit box */
           if (( (x >= 500) && (y >= 100) )
                   && ( (x < 560) && (y < 120) ))
                        {
                        sound(3000,1);
                        break;
                        }
                           /* see if in box box */
           if (( (x >= 500) && (y >= 150) )
                   && ( (x < 560) && (y < 170) ))
                        {
                        lpress=rpress=false;
                        plotpix = false;
                        constr = true;     /*(x1,x2,y1,y2)*/
                        mconstrain(xdivisor*70,xdivisor*269,70,169);
                        set_pos(70,269,70,169);
                        sound(2048,1);
                        }
           if (( (x >= 90) && (y >= 100) )
                   && ( (x < 150) && (y < 120) ))
                        {
                        lpress=rpress=false;
                        plotpix = false;
                        constr = false;
                        mconstrain(0,639,0,479);
                        sound(1024,1);
                        }
           if (( (x >= 190) && (y >= 100) )
                   && ( (x < 250) && (y < 120) ))
                        {
          /* only in version 2 or greater of Mix C */
                        lpress=rpress=false;
                        plotpix = false;
                        msave();
                        mcursor_off();
                        sound(2800,1);
                        setvmode(DEFAULTMODE);
                        system("c:\command.com");
                        setvmode(cmode);
                        display_screen();
                        mrestore();
                        }

           move_to(x,y);        /* do for other graphics */

           switch(getpixel(x,y))
             {
             case  9 : if (color ==  9) {pen_color(9); break;}
                       if (color == 14) pen_color(11);  /* cyan  */
                       else pen_color(13); break;       /* magenta */

             case 14 : if (color == 14) {pen_color(14); break;}
                       if (color ==  9) pen_color(11);
                       else pen_color(10); break;       /* green */

             case 12 : if (color == 12) {pen_color(12); break;}
                       if (color == 14) pen_color(10);
                       else pen_color(13); break;

             case  7 :
             case 11 :
             case 13 :
             case 10 : pen_color(7);
                       break;
             case  0 :
             default : pen_color(color);   break;
             }

           if (cmode == 19) pen_color(rand() % 256);

           if (plotpix) setpixel(x,y);
           plotpix = true;
           goto faster;        /* bypass keyboard thing when mousepressed */
           }

        }      /* end of the loop...event driven */

      setvmode(DEFAULTMODE);
      }
   else
      {

      if (!mreset())        /* reset mouse */
         {
         fprintf(stderr,"Cannot initialize the Mouse!\n");
         exit(0);
         }
      printf("Mouse initialization. ");
      printf("In video mode %d.\n",getvmode());
      printf("Type any key to continue...");
      getch();

      }

   if (mint) mreset();    /* stop the interrupts from happining */
   mcursor_off();
   exit(0);
   }


/* set to the mid position of some points */
void set_pos(x1,x2,y1,y2)
int   x1,x2,y1,y2;
  {
  msetpos((x2+x1)/2,(y2+y1)/2);
  }

/* process keystrokes here */
pr_key(kst)
int kst;
  {
  unsigned int a,b,x,y;
  switch(toupper((char)kst))
      {

      case 'S' :  if (bsave)
                     {
                     bsave = false;
                     msave();
                     }
                  else
                     {
                     bsave = true;
                     mrestore();
                     }
                  break;

      case 'P' :  mcenter();
                  break;

      case 'I' :  if (!mint)
                     {
                     moubuf = _fmalloc(MSIZE);
                     if (moubuf == NULL) break;
                     minitial(FP_OFF(moubuf),FP_SEG(moubuf),MSIZE);
                     mint = true;
                     }
                  else
                     {
                     _ffree(moubuf);
                     mreset();
                     mint = false;
                     }
                  break;

      case 'C' :  if (constr)
                     {
                     constr = false;
                     mconstrain(0,639,0,479);
                     sound(1024,1);
                     }
                  else
                     {
                     constr = true;     /*(x1,x2,y1,y2)*/
                     mconstrain(xdivisor*70,xdivisor*269,70,169);
                     set_pos(70,269,70,169);
                     sound(2048,1);
                     }
                  break;

      default  :  printf("%c",kst);
                  break;
      }

  }

/* display the boxes and text on the screen */
void display_screen()
   {
   poscurs(0,0);
   printf("%04X driver version %04X mouse type",mgetver(),mgettype());

   poscurs(20,9);
   printf("Type C to trap mouse cursor in box, press again to free.");

   poscurs(21,9);
   printf("Type P to position to center of the screen (v 7.04)");

   poscurs(22,9);
   printf("Type S to save/restore the mouse state");

   poscurs(24,9);
   printf("Type I to initialize Mouse Interrupts (I to stop too).");

   msetpos(300,10);     /* reposition the mouse cursor */

   if (graphic)         /* display some graphic devices */
      {
      move_to(70,70);

      pen_color(2);
      box(200,100,1);

      move_to( 90,100);  pbox(20);
      move_to(102,105);  plots("Free");

      move_to(190,100);  pbox(20);
      move_to(198,106);  plots("System");

      move_to(500,100);  pbox(20);
      move_to(512,106);  plots("Exit");

      move_to(500,150);  pbox(20);
      move_to(515,156);  plots("Box");
      }
    }


/* pbox does a rectangular box of size requested */
pbox(size)
int size;
  {

  pen_color(15);
  box(3*size,size,1);

  pen_color(7);
  move_by(-1,-1);
  box(3*size,size,0);
  move_by(-1,-1);
  box(3*(size)+2,size+1,0);
  move_by(2,2);
  }

/* Note that Power C is a trademark of Mix Software

  end of the mouse test routines */













